open System.Collections.Generic
type ('a, 'b) t = Dictionary<'a, 'b>;;

let create : int -> Dictionary<'a,'b> when 'a : equality =
  fun n -> new Dictionary<'a,'b>(n);;
let clear (z : ('a, 'b) t) : unit = z.Clear();;
(*let reset (z : ('a, 'b) t) = z.Reset()
let copy (z : ('a, 'b) t) = z.Copy()*)
let add (z : ('a, 'b) t) (k : 'a) (v : 'b) : unit = z.Add(k, v);;
let find (z : ('a, 'b) t) (k : 'a) : 'b = z.[k];;
let mem (z : ('a, 'b) t) (k : 'a) : bool = z.ContainsKey(k);;
let remove (z : ('a, 'b) t) (k : 'a) : unit = let _ = z.Remove(k) in ();;
let iter (f : 'a->'b->unit) (z : ('a, 'b) t) : unit =
  for kv in z
  do f kv.Key kv.Value
  done ;;
let fold (f : 'a->'b->'c->'c) (z : ('a, 'b) t) (x0 : 'c) : 'c =
  let x = ref x0 in
  for kv in z
  do x := f kv.Key kv.Value !x
  done ; !x;;
