type t = int64
let shift_left : t -> int -> t =
  fun x y -> x <<< y;;
let shift_right : t -> int -> t =
  fun x y -> x >>> y;;
let shift_right_logical : t -> int -> t =
  fun x y -> int64(uint64(x) >>> y);;

let lognot : t -> t = fun x -> ~~~x;;
let logand : t -> t -> t = fun x y -> x &&& y;;
let logor : t -> t -> t = fun x y -> x ||| y;;
let logxor : t -> t -> t = fun x y -> x ^^^ y;;

let neg : t -> t = fun x -> -x;;
let add : t -> t -> t = fun x y -> x + y;;
let sub : t -> t -> t = fun x y -> x - y;;
let mul : t -> t -> t = fun x y -> x * y;;
let div : t -> t -> t = fun x y -> x / y;;
let rem : t -> t -> t = fun x y -> x % y;;

let to_int : t -> int = fun x -> int(x);;
let of_int : int -> t = fun x -> int64(x);;
let to_int32 : t -> int32 = fun x -> int32(x);;
let of_int32 : int32 -> t = fun x -> int64(x);;
