open AST
open BinNums
open Conventions
open Conventions1
open Coqlib
open Datatypes
open InterfGraph
open List0
open Locations
open Machregs
open Maps
open Op
open RTL
open RTLtyping
open Registers

val add_interf_live : (reg -> bool) -> reg -> Regset.t -> graph -> graph

val add_interf_op : reg -> Regset.t -> graph -> graph

val add_interf_move : reg -> reg -> Regset.t -> graph -> graph

val add_interf_destroyed : Regset.t -> mreg list -> graph -> graph

val add_interfs_indirect_call : reg -> loc list -> graph -> graph

val add_interf_call : (reg, ident) sum -> loc list -> graph -> graph

val add_prefs_call : reg list -> loc list -> graph -> graph

val add_prefs_builtin :
  external_function -> reg list -> reg -> graph -> graph

val add_interf_entry : reg list -> Regset.t -> graph -> graph

val add_interf_params : reg list -> graph -> graph

val add_edges_instr : signature -> instruction -> Regset.t -> graph -> graph

val add_edges_instrs : coq_function -> Regset.t PMap.t -> graph

val interf_graph : coq_function -> Regset.t PMap.t -> Regset.t -> graph

val graph_coloring :
  coq_function -> graph -> regenv -> Regset.t -> reg -> loc

val check_coloring_1 : graph -> (reg -> loc) -> bool

val check_coloring_2 : graph -> (reg -> loc) -> bool

val same_typ : typ -> typ -> bool

val loc_is_acceptable : loc -> bool

val check_coloring_3 : Regset.t -> regenv -> (reg -> loc) -> bool

val check_coloring : graph -> regenv -> Regset.t -> (reg -> loc) -> bool

val alloc_of_coloring :
  (reg -> loc) -> regenv -> Regset.t -> Regset.elt -> loc

val regalloc :
  coq_function -> Regset.t PMap.t -> Regset.t -> regenv -> (Regset.elt ->
  loc) option

