open Allocation
open Asm
open Asmgen
open CSE
open CleanupLabels
open Clight
open Cminor
open Cminorgen
open Constprop
open Cshmgen
open Csyntax
open Errors
open Inlining
open LTLin
open Linearize
open Mach
open RRE
open RTL
open RTLgen
open Reload
open Renumber
open Selection
open SimplExpr
open SimplLocals
open Stacking
open Tailcall
open Tunneling

(* F# *)
let print_Clight :  Clight.program -> unit =
  fun x -> Printf.printf "print_Clight\n"
    (* PrintClight.print_if *)

let print_Cminor :  Cminor.program -> unit =
  fun x -> Printf.printf "print_Cminor\n"
    (* PrintCminor.print_if *)

let print_RTL :  program -> unit =
  fun x -> Printf.printf "print_RTL\n"
    (* PrintRTL.print_rtl *)

let print_RTL_tailcall :  program -> unit =
  fun x -> Printf.printf "print_RTL_tailcall\n"
    (* PrintRTL.print_tailcall *)

let print_RTL_inline :  program -> unit =
  fun x -> Printf.printf "print_RTL_inline\n"
    (* PrintRTL.print_inlining *)

let print_RTL_constprop :  program -> unit =
  fun x -> Printf.printf "print_RTL_constprop\n"
    (* PrintRTL.print_constprop *)

let print_RTL_cse :  program -> unit =
  fun x -> Printf.printf "print_RTL_cse\n"
    (* PrintRTL.print_cse *)

let print_LTLin :  LTLin.program -> unit =
  fun x -> Printf.printf "print_RTL_cse\n"
    (* PrintLTLin.print_if *)

let print_Mach :  Mach.program -> unit =
  fun x -> Printf.printf "print_Mach\n"
    (* PrintMach.print_if *)

let apply_total :  'a1 Errors.res -> ('a1 -> 'a2) -> 'a2 Errors.res =
  fun x f  ->
  match x with
  | Errors.OK x1 -> Errors.OK (f x1)
  | Errors.Error msg -> Errors.Error msg

let apply_partial :     'a1 Errors.res -> ('a1 -> 'a2 Errors.res) -> 'a2 Errors.res =
  fun x f  ->
  match x with
  | Errors.OK x1 -> f x1
  | Errors.Error msg -> Errors.Error msg

let print :  ('a1 -> unit) -> 'a1 -> 'a1 =
    fun (f: 'a1 -> unit) (x: 'a1) -> f x; x

let transf_rtl_program :  program -> Asm.program Errors.res =
  fun f  ->
  apply_partial
    (apply_total
      (apply_partial
        (apply_total
          (apply_total
            (apply_total
              (apply_total
                (apply_partial
                  (apply_total
                    (apply_partial
                      (apply_total
                        (apply_partial
                          (apply_total
                            (apply_total
                              (apply_total
                                (apply_total
                                  (apply_total
                                    (apply_partial
                                      (apply_total
                                        (apply_total
                                          (apply_total (Errors.OK f)
                                            (print print_RTL))
                                          transf_program)
                                        (print print_RTL_tailcall))
                                      Inlining.transf_program)
                                    Renumber.transf_program)
                                  (print print_RTL_inline))
                                Constprop.transf_program)
                              Renumber.transf_program)
                            (print print_RTL_constprop)) CSE.transf_program)
                        (print print_RTL_cse)) Allocation.transf_program)
                    tunnel_program) Linearize.transf_program)
                CleanupLabels.transf_program) (print print_LTLin))
            Reload.transf_program) RRE.transf_program)
        Stacking.transf_program) (print print_Mach)) Asmgen.transf_program

let transf_cminor_program :  Cminor.program -> Asm.program Errors.res =
  fun p  ->
  apply_partial
    (apply_partial
      (apply_total (apply_total (Errors.OK p) (print print_Cminor))
        sel_program) RTLgen.transl_program) transf_rtl_program

let transf_clight_program :  Clight.program -> Asm.program Errors.res =
  fun p  ->
  apply_partial
    (apply_partial
      (apply_partial
        (apply_partial (apply_total (Errors.OK p) (print print_Clight))
          SimplLocals.transf_program) Cshmgen.transl_program)
      Cminorgen.transl_program) transf_cminor_program

let transf_c_program :  Csyntax.program -> Asm.program Errors.res =
  fun p  ->
  apply_partial (apply_partial (Errors.OK p) transl_program)
    transf_clight_program

