open Allocation
open Asm
open Asmgen
open CSE
open CleanupLabels
open Clight
open Cminor
open Cminorgen
open Constprop
open Cshmgen
open Csyntax
open Errors
open Inlining
open LTLin
open Linearize
open Mach
open RRE
open RTL
open RTLgen
open Reload
open Renumber
open Selection
open SimplExpr
open SimplLocals
open Stacking
open Tailcall
open Tunneling

val print_Clight : Clight.program -> unit

val print_Cminor : Cminor.program -> unit

val print_RTL : program -> unit

val print_RTL_tailcall : program -> unit

val print_RTL_inline : program -> unit

val print_RTL_constprop : program -> unit

val print_RTL_cse : program -> unit

val print_LTLin : LTLin.program -> unit

val print_Mach : Mach.program -> unit

val apply_total : 'a1 Errors.res -> ('a1 -> 'a2) -> 'a2 Errors.res

val apply_partial :
  'a1 Errors.res -> ('a1 -> 'a2 Errors.res) -> 'a2 Errors.res

val print : ('a1 -> unit) -> 'a1 -> 'a1

val transf_rtl_program : program -> Asm.program Errors.res

val transf_cminor_program : Cminor.program -> Asm.program Errors.res

val transf_clight_program : Clight.program -> Asm.program Errors.res

val transf_c_program : Csyntax.program -> Asm.program Errors.res

