open AST
open Conventions1
open List0
open Locations
open Machregs

let parameter_of_argument :  loc -> loc =
  fun l  ->
    match l with
| R m -> l
| S s ->
  (match s with
   | Outgoing (n, ty) -> S (Incoming (n, ty))
   | _ -> l)

let loc_parameters :  signature -> loc list =
  fun s  ->
  map parameter_of_argument (loc_arguments s)

let tailcall_is_possible :  signature -> bool =
  fun sg  ->
  let rec tcisp = function
  | [] -> true
  | l0 :: l' ->
    (match l0 with
     | R m -> tcisp l'
     | S s -> false)
  in tcisp (loc_arguments sg)

let rec arity_ok_rec :  typ list -> mreg list -> mreg list -> bool =
  fun tys itmps ftmps  ->
  match tys with
  | [] -> true
  | t :: ts ->
    (match t with
     | Tint ->
       (match itmps with
        | [] -> false
        | it1 :: its -> arity_ok_rec ts its ftmps)
     | Tfloat ->
       (match ftmps with
        | [] -> false
        | ft1 :: fts -> arity_ok_rec ts itmps fts))

let arity_ok :  typ list -> bool =
  fun tys  ->
  arity_ok_rec tys int_temporaries float_temporaries

