(* *********************************************************************)
(*                                                                     *)
(*              The Compcert verified compiler                         *)
(*                                                                     *)
(*          Xavier Leroy, INRIA Paris-Rocquencourt                     *)
(*                                                                     *)
(*  Copyright Institut National de Recherche en Informatique et en     *)
(*  Automatique.  All rights reserved.  This file is distributed       *)
(*  under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation, either version 2 of the License, or  *)
(*  (at your option) any later version.  This file is also distributed *)
(*  under the terms of the INRIA Non-Commercial License Agreement.     *)
(*                                                                     *)
(* *********************************************************************)

val print_idents_in_full : bool ref
val print_line_numbers : bool ref

val location : System.IO.TextWriter -> C.location -> unit
val attributes : System.IO.TextWriter -> C.attributes -> unit
val typ : System.IO.TextWriter -> C.typ -> unit
val simple_decl : System.IO.TextWriter -> C.ident * C.typ -> unit
val full_decl: System.IO.TextWriter -> C.decl -> unit
val constant : System.IO.TextWriter -> C.constant -> unit
val exp : System.IO.TextWriter -> int * C.exp -> unit
val opt_exp : System.IO.TextWriter -> C.stmt -> unit
val stmt : System.IO.TextWriter -> C.stmt -> unit
val fundef : System.IO.TextWriter -> C.fundef -> unit
val init : System.IO.TextWriter -> C.init -> unit
val storage : System.IO.TextWriter -> C.storage -> unit
val field : System.IO.TextWriter -> C.field -> unit
val globdecl : System.IO.TextWriter -> C.globdecl -> unit
val program : System.IO.TextWriter -> C.program -> unit
