let xorb :  bool -> bool -> bool =
  fun b1 b2  ->
  if b1 then if b2 then false else true else b2

let negb :  bool -> bool =
    function
| true -> false
| false -> true

type nat =
| O
| S of nat

type ('a, 'b) sum =
| Coq_inl of 'a
| Coq_inr of 'b

let fst :  ('a1 * 'a2) -> 'a1 =
    function
| (x, y) -> x

let snd :  ('a1 * 'a2) -> 'a2 =
    function
| (x, y) -> y

let rec length :  'a1 list -> nat =
    function
| [] -> O
| y :: l' -> S (length l')

let rec app :  'a1 list -> 'a1 list -> 'a1 list =
  fun l m  ->
  match l with
  | [] -> m
  | a :: l1 -> a :: (app l1 m)

type comparison =
| Eq
| Lt
| Gt

let coq_CompOpp :  comparison -> comparison =
    function
| Eq -> Eq
| Lt -> Gt
| Gt -> Lt

type coq_CompareSpecT =
| CompEqT
| CompLtT
| CompGtT

let coq_CompareSpec2Type :  comparison -> coq_CompareSpecT =
    function
| Eq -> CompEqT
| Lt -> CompLtT
| Gt -> CompGtT

type coq_CompSpecT = coq_CompareSpecT

let coq_CompSpec2Type :  'a1 -> 'a1 -> comparison -> coq_CompSpecT =
  fun x y c  ->
  coq_CompareSpec2Type c

