open AST
open Events
open Integers

type world =
| World of (ident -> eventval list -> (eventval * world) option)
   * (memory_chunk -> ident -> Int.int -> (eventval * world) option)
   * (memory_chunk -> ident -> Int.int -> eventval -> world option)

let nextworld_io :     world -> ident -> eventval list -> (eventval * world) option =
  fun w evname evargs  ->
  let (World (io, vl, vs)) = w in io evname evargs

let nextworld_vload :     world -> memory_chunk -> ident -> Int.int -> (eventval * world) option =
  fun w chunk id ofs  ->
  let (World (io, vl, vs)) = w in vl chunk id ofs

let nextworld_vstore :     world -> memory_chunk -> ident -> Int.int -> eventval -> world option =
  fun w chunk id ofs v  ->
  let (World (io, vl, vs)) = w in vs chunk id ofs v

