open BinInt
open BinNums
open BinPos
open Datatypes
open Fappli_IEEE
open Fappli_IEEE_bits
open Fcore_Zaux
open Integers

type float = binary64

module Float : 
 sig 
  val zero : float
  
  val eq_dec : float -> float -> bool
  
  val neg : float -> float
  
  val abs : float -> float
  
  val binary_normalize64 : coq_Z -> coq_Z -> bool -> float
  
  val binary_normalize32 : coq_Z -> coq_Z -> bool -> binary32
  
  val floatofbinary32 : binary32 -> float
  
  val binary32offloat : float -> binary32
  
  val singleoffloat : float -> float
  
  val coq_Zoffloat : float -> coq_Z option
  
  val intoffloat : float -> Int.int option
  
  val intuoffloat : float -> Int.int option
  
  val build_from_parsed_obligation_1 :
    coq_Z -> coq_Z -> positive -> positive -> coq_Z -> positive ->
    binary_float
  
  val build_from_parsed_obligation_2 :
    coq_Z -> coq_Z -> positive -> positive -> coq_Z -> positive -> positive
    -> binary_float
  
  val build_from_parsed :
    coq_Z -> coq_Z -> positive -> positive -> coq_Z -> binary_float
  
  val build_from_parsed64 : positive -> positive -> coq_Z -> float
  
  val build_from_parsed32 : positive -> positive -> coq_Z -> float
  
  val floatofint : Int.int -> float
  
  val floatofintu : Int.int -> float
  
  val add : float -> float -> float
  
  val sub : float -> float -> float
  
  val mul : float -> float -> float
  
  val div : float -> float -> float
  
  val order_float : float -> float -> Datatypes.comparison option
  
  val cmp : comparison -> float -> float -> bool
  
  val bits_of_double : float -> Int64.int
  
  val double_of_bits : Int64.int -> float
  
  val bits_of_single : float -> Int.int
  
  val single_of_bits : Int.int -> float
  
  val from_words : Int.int -> Int.int -> float
  
  val ox8000_0000 : Int.int
  
  val ox4330_0000 : Int.int
 end

