open BinInt
open BinNums
open ZArith_dec

module Z_as_Int = 
 struct 
  type t = coq_Z
  
  (** val _0 : coq_Z **)
  
  let _0 =
    Z0
  
  (** val _1 : coq_Z **)
  
  let _1 =
    Zpos Coq_xH
  
  (** val _2 : coq_Z **)
  
  let _2 =
    Zpos (Coq_xO Coq_xH)
  
  (** val _3 : coq_Z **)
  
  let _3 =
    Zpos (Coq_xI Coq_xH)
  
  (** val plus : coq_Z -> coq_Z -> coq_Z **)
  
  let plus x y =
    Z.add x y
  
  (** val opp : coq_Z -> coq_Z **)
  
  let opp x =
    Z.opp x
  
  (** val minus : coq_Z -> coq_Z -> coq_Z **)
  
  let minus x y =
    Z.sub x y
  
  (** val mult : coq_Z -> coq_Z -> coq_Z **)
  
  let mult x y =
    Z.mul x y
  
  (** val max : coq_Z -> coq_Z -> coq_Z **)
  
  let max x y =
    Z.max x y
  
  (** val gt_le_dec : coq_Z -> coq_Z -> bool **)
  
  let gt_le_dec x y =
    coq_Z_gt_le_dec x y
  
  (** val ge_lt_dec : coq_Z -> coq_Z -> bool **)
  
  let ge_lt_dec x y =
    coq_Z_ge_lt_dec x y
  
  (** val eq_dec : coq_Z -> coq_Z -> bool **)
  
  let eq_dec x y =
    Z.eq_dec x y
  
  (** val i2z : t -> coq_Z **)
  
  let i2z : t -> coq_Z = fun n ->
    n
 end

