open Datatypes
open Specif

let tl :  'a1 list -> 'a1 list =
    function
| [] -> []
| a :: m -> m

let rec in_dec :  ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 list -> bool =
  fun h a  ->
    function
| [] -> false
| y :: l0 -> let s = h y a in if s then true else in_dec h a l0

let rec nth_error :  'a1 list -> nat -> 'a1 coq_Exc =
  fun l  ->
    function
| O ->
  (match l with
   | [] -> error
   | x :: l0 -> value x)
| S n0 ->
  (match l with
   | [] -> error
   | a :: l0 -> nth_error l0 n0)

let rec remove :  ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 list -> 'a1 list =
  fun eq_dec x  ->
    function
| [] -> []
| y :: tl0 ->
  if eq_dec x y then remove eq_dec x tl0 else y :: (remove eq_dec x tl0)

let rec rev :  'a1 list -> 'a1 list =
    function
| [] -> []
| x :: l' -> app (rev l') (x :: [])

let rec list_eq_dec :     ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool =
  fun eq_dec l l'  ->
  match l with
  | [] ->
    (match l' with
     | [] -> true
     | a :: l0 -> false)
  | y :: l0 ->
    (match l' with
     | [] -> false
     | a0 :: l1 -> if eq_dec y a0 then list_eq_dec eq_dec l0 l1 else false)

let rec map :  ('a1 -> 'a2) -> 'a1 list -> 'a2 list =
  fun f  ->
    function
| [] -> []
| a :: t -> (f a) :: (map f t)

let rec fold_left :  ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1 =
  fun f l a0  ->
  match l with
  | [] -> a0
  | b :: t -> fold_left f t (f a0 b)

let rec fold_right :  ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1 =
  fun f a0  ->
    function
| [] -> a0
| b :: t -> f b (fold_right f a0 t)

let rec forallb :  ('a1 -> bool) -> 'a1 list -> bool =
  fun f  ->
    function
| [] -> true
| a :: l0 -> (&&) (f a) (forallb f l0)

let rec filter :  ('a1 -> bool) -> 'a1 list -> 'a1 list =
  fun f  ->
    function
| [] -> []
| x :: l0 -> if f x then x :: (filter f l0) else filter f l0

let rec combine :  'a1 list -> 'a2 list -> ('a1 * 'a2) list =
  fun l l'  ->
  match l with
  | [] -> []
  | x :: tl0 ->
    (match l' with
     | [] -> []
     | y :: tl' -> (x, y) :: (combine tl0 tl'))

