open AST
open BinInt
open BinNums
open Coqlib
open Machregs

type slot =
| Local of coq_Z * typ
| Incoming of coq_Z * typ
| Outgoing of coq_Z * typ

val slot_type : slot -> typ

val slot_eq : slot -> slot -> bool

val typesize : typ -> coq_Z

type loc =
| R of mreg
| S of slot

module Loc : 
 sig 
  val coq_type : loc -> typ
  
  val eq : loc -> loc -> bool
  
  val overlap_aux : typ -> coq_Z -> coq_Z -> bool
  
  val overlap : loc -> loc -> bool
  
  val diff_dec : loc -> loc -> bool
 end

