open AST
open BinNums

type mreg =
| AX
| BX
| SI
| DI
| BP
| X0
| X1
| X2
| X3
| X4
| X5
| IT1
| IT2
| FT1
| FT2
| FP0

let mreg_eq :  mreg -> mreg -> bool =
  fun r1 r2  ->
  match r1 with
  | AX ->
    (match r2 with
     | AX -> true
     | _ -> false)
  | BX ->
    (match r2 with
     | BX -> true
     | _ -> false)
  | SI ->
    (match r2 with
     | SI -> true
     | _ -> false)
  | DI ->
    (match r2 with
     | DI -> true
     | _ -> false)
  | BP ->
    (match r2 with
     | BP -> true
     | _ -> false)
  | X0 ->
    (match r2 with
     | X0 -> true
     | _ -> false)
  | X1 ->
    (match r2 with
     | X1 -> true
     | _ -> false)
  | X2 ->
    (match r2 with
     | X2 -> true
     | _ -> false)
  | X3 ->
    (match r2 with
     | X3 -> true
     | _ -> false)
  | X4 ->
    (match r2 with
     | X4 -> true
     | _ -> false)
  | X5 ->
    (match r2 with
     | X5 -> true
     | _ -> false)
  | IT1 ->
    (match r2 with
     | IT1 -> true
     | _ -> false)
  | IT2 ->
    (match r2 with
     | IT2 -> true
     | _ -> false)
  | FT1 ->
    (match r2 with
     | FT1 -> true
     | _ -> false)
  | FT2 ->
    (match r2 with
     | FT2 -> true
     | _ -> false)
  | FP0 ->
    (match r2 with
     | FP0 -> true
     | _ -> false)

let mreg_type :  mreg -> typ =
    function
| AX -> Tint
| BX -> Tint
| SI -> Tint
| DI -> Tint
| BP -> Tint
| IT1 -> Tint
| IT2 -> Tint
| _ -> Tfloat

module IndexedMreg = 
 struct 
  type t = mreg
  
  (** val eq : mreg -> mreg -> bool **)
  
  let eq x y =
    mreg_eq x y
  
  (** val index : mreg -> positive **)
  
  let index = function
  | AX -> Coq_xH
  | BX -> Coq_xO Coq_xH
  | SI -> Coq_xI Coq_xH
  | DI -> Coq_xO (Coq_xO Coq_xH)
  | BP -> Coq_xI (Coq_xO Coq_xH)
  | X0 -> Coq_xO (Coq_xI Coq_xH)
  | X1 -> Coq_xI (Coq_xI Coq_xH)
  | X2 -> Coq_xO (Coq_xO (Coq_xO Coq_xH))
  | X3 -> Coq_xI (Coq_xO (Coq_xO Coq_xH))
  | X4 -> Coq_xO (Coq_xI (Coq_xO Coq_xH))
  | X5 -> Coq_xI (Coq_xI (Coq_xO Coq_xH))
  | IT1 -> Coq_xO (Coq_xO (Coq_xI Coq_xH))
  | IT2 -> Coq_xI (Coq_xO (Coq_xI Coq_xH))
  | FT1 -> Coq_xO (Coq_xI (Coq_xI Coq_xH))
  | FT2 -> Coq_xI (Coq_xI (Coq_xI Coq_xH))
  | FP0 -> Coq_xO (Coq_xO (Coq_xO (Coq_xO Coq_xH)))
 end

