open AST
open BinInt
open BinNums
open Coqlib
open Datatypes
open EqNat
open Floats
open Integers
open List0
open Values

val size_chunk : memory_chunk -> coq_Z

val size_chunk_nat : memory_chunk -> nat

val align_chunk : memory_chunk -> coq_Z

type memval =
| Undef
| Byte of Byte.int
| Pointer of block * Int.int * nat

val bytes_of_int : nat -> coq_Z -> Byte.int list

val int_of_bytes : Byte.int list -> coq_Z

val big_endian : bool

val rev_if_be : Byte.int list -> Byte.int list

val encode_int : nat -> coq_Z -> Byte.int list

val decode_int : Byte.int list -> coq_Z

val inj_bytes : Byte.int list -> memval list

val proj_bytes : memval list -> Byte.int list option

val inj_pointer : nat -> block -> Int.int -> memval list

val check_pointer : nat -> block -> Int.int -> memval list -> bool

val proj_pointer : memval list -> coq_val

val encode_val : memory_chunk -> coq_val -> memval list

val decode_val : memory_chunk -> memval list -> coq_val

