open AST
open Conventions1
open Coqlib
open Datatypes
open Linear
open List0
open Locations
open Machregs
open Op

type equation = { e_reg : mreg; e_slot : slot }

val e_reg : equation -> mreg

val e_slot : equation -> slot

type equations = equation list

val find_reg_containing : slot -> equations -> mreg option

val eq_equation : equation -> equation -> bool

val contains_equation : slot -> mreg -> equations -> bool

val kill_loc : loc -> equations -> equations

val kill_locs : loc list -> equations -> equations

val kill_temps : equations -> equations

val kill_at_move : equations -> equations

val kill_op : operation -> equations -> equations

val is_incoming : slot -> bool

val safe_move_insertion : code -> bool

val transf_code : equations -> code -> code

val transf_function : coq_function -> coq_function

val transf_fundef : fundef -> fundef

val transf_program : program -> program

