open AST
open BinInt
open BinNums
open Conventions
open Coqlib
open Datatypes
open Errors
open Integers
open List0
open Maps
open Op
open RTL
open Registers

type regenv = reg -> typ

val infer_type_environment :
  coq_function -> (node * instruction) list -> regenv option

val check_reg : regenv -> reg -> typ -> bool

val check_regs : regenv -> reg list -> typ list -> bool

val check_op : regenv -> operation -> reg list -> reg -> bool

val check_successor : coq_function -> node -> bool

val check_instr : coq_function -> regenv -> instruction -> bool

val check_params_norepet : reg list -> bool

val check_instrs :
  coq_function -> regenv -> (node * instruction) list -> bool

val type_function : coq_function -> regenv res

