open AST
open Conventions
open Conventions1
open Datatypes
open Integers
open LTLin
open Linear
open List0
open Locations
open Machregs
open Op
open Parallelmove

val reg_for : loc -> mreg

val regs_for_rec : loc list -> mreg list -> mreg list -> mreg list

val regs_for : loc list -> mreg list

val enough_temporaries_rec : loc list -> mreg list -> mreg list -> bool

val enough_temporaries : loc list -> bool

val add_spill : mreg -> loc -> code -> code

val add_reload : loc -> mreg -> code -> code

val add_reloads : loc list -> mreg list -> code -> code

val add_move : loc -> loc -> code -> code

val parallel_move : loc list -> loc list -> code -> code

val transf_instr : LTLin.coq_function -> LTLin.instruction -> code -> code

val transf_code : LTLin.coq_function -> LTLin.code -> code

val transf_function : LTLin.coq_function -> coq_function

val transf_fundef : LTLin.fundef -> fundef

val transf_program : LTLin.program -> program

