open AST
open Cminor
open CminorSel
open Datatypes
open Globalenvs
open Integers
open Op
open SelectOp

val condition_of_expr : expr -> condition * exprlist

val load : memory_chunk -> expr -> expr

val store : memory_chunk -> expr -> expr -> stmt

val sel_constant : constant -> expr

val sel_unop : unary_operation -> expr -> expr

val sel_binop : binary_operation -> expr -> expr -> expr

val sel_expr : Cminor.expr -> expr

val sel_exprlist : Cminor.expr list -> exprlist

type call_kind =
| Call_default
| Call_imm of ident
| Call_builtin of external_function

val expr_is_addrof_ident : Cminor.expr -> ident option

val classify_call : genv -> Cminor.expr -> call_kind

val sel_stmt : genv -> Cminor.stmt -> stmt

val sel_function : genv -> Cminor.coq_function -> coq_function

val sel_fundef : genv -> Cminor.fundef -> fundef

val sel_program : Cminor.program -> program

