open AST
open Datatypes
open LTL
open List0
open Maps

module U = 
 struct 
  type elt = PTree.elt
  
  (** val elt_eq : elt -> elt -> bool **)
  
  let elt_eq x y = PTree.elt_eq x y (* ??? F# *)
  
  type t = PTree.elt PTree.t (* ??? F# *)

  (** val repr : t -> elt -> elt **)
  
  let repr : t -> elt -> elt = fun x y ->
    failwith "AXIOM TO BE REALIZED"
  
  (** val empty : t **)
  
  let empty : t = PTree.empty
  
  (** val find : t -> elt -> elt * t **)
  
  let find : t -> elt -> elt * t = fun x y ->
     failwith "AXIOM TO BE REALIZED"
 
  (** val union : t -> elt -> elt -> t **)
  
  let union : t -> elt -> elt -> t = fun x y z ->
    failwith "AXIOM TO BE REALIZED"
  
  (** val merge : t -> elt -> elt -> t **)
  
  let merge : t -> elt -> elt -> t = fun x y z ->
    failwith "AXIOM TO BE REALIZED"
  
  (** val pathlen : t -> elt -> nat **)
  
  let pathlen : t -> elt -> nat = fun x y ->
    failwith "AXIOM TO BE REALIZED"
 end

let record_goto :  U.t -> node -> instruction -> U.t =
  fun uf pc  ->
    function
| Lnop s -> U.union uf pc s
| _ -> uf

let record_gotos :  coq_function -> U.t =
  fun f  ->
  PTree.fold record_goto f.fn_code U.empty

let tunnel_instr :  U.t -> instruction -> instruction =
  fun uf  ->
    function
| Lnop s -> Lnop (U.repr uf s)
| Lop (op, args, res, s) -> Lop (op, args, res, (U.repr uf s))
| Lload (chunk, addr, args, dst, s) ->
  Lload (chunk, addr, args, dst, (U.repr uf s))
| Lstore (chunk, addr, args, src, s) ->
  Lstore (chunk, addr, args, src, (U.repr uf s))
| Lcall (sig0, ros, args, res, s) ->
  Lcall (sig0, ros, args, res, (U.repr uf s))
| Lbuiltin (ef, args, res, s) -> Lbuiltin (ef, args, res, (U.repr uf s))
| Lcond (cond, args, s1, s2) ->
  Lcond (cond, args, (U.repr uf s1), (U.repr uf s2))
| Ljumptable (arg, tbl) -> Ljumptable (arg, (map (U.repr uf) tbl))
| x -> x

let tunnel_function :  coq_function -> coq_function =
  fun f  ->
  let uf = record_gotos f in
  { fn_sig = f.fn_sig; fn_params = f.fn_params; fn_stacksize =
  f.fn_stacksize; fn_code =
  (PTree.map (fun pc b -> tunnel_instr uf b) f.fn_code); fn_entrypoint =
  (U.repr uf f.fn_entrypoint) }

let tunnel_fundef :  fundef -> fundef =
  fun f  ->
  transf_fundef tunnel_function f

let tunnel_program :  program -> program =
  fun p  ->
  transform_program tunnel_fundef p

