open BinNums
open BinPos
open Datatypes
open Peano

let shift_nat :  nat -> positive -> positive =
  fun n z  ->
  nat_iter n (fun x -> Coq_xO x) z

let shift_pos :  positive -> positive -> positive =
  fun n z  ->
  Pos.iter n (fun x -> Coq_xO x) z

let two_power_nat :  nat -> coq_Z =
  fun n  ->
  Zpos (shift_nat n Coq_xH)

let two_power_pos :  positive -> coq_Z =
  fun x  ->
  Zpos (shift_pos x Coq_xH)

let two_p :  coq_Z -> coq_Z =
    function
| Z0 -> Zpos Coq_xH
| Zpos y -> two_power_pos y
| Zneg y -> Z0

