type nodestate = A | B

type node = {
    ident : int;
    regclass: int;                      (*r identifier of register class *)
    mutable accesses: int;              (*r number of defs and uses *)
    mutable spillcost: float;           (*r estimated cost of spilling *)
    mutable adjlist: node list;         (*r all nodes it interferes with *)
    mutable degree: int;                (*r number of adjacent nodes *)
    mutable nstate: nodestate;          (*r in which set of nodes it is *)
    mutable nprev: node;                (*r for double linking *)
    mutable nnext: node                 (*r for double linking *)
  }

let make state =
    let rec empty =
      { ident = 0;
        regclass = 0;
        accesses = 0; spillcost = 0.0;
        adjlist = []; degree = 0;
        nstate = state ;
        nprev = empty; nnext = empty }
    in empty
